/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package i18n;

import java.awt.Dimension;
import java.awt.Image;
import javax.swing.Icon;
import javax.swing.ImageIcon;

/**
 *
 * @author favdb
 */
class IconUtil {

	public static ImageIcon createImageIcon(String path) {
		java.net.URL imgURL = I18N.class.getResource(path);
		if (imgURL != null) {
			return new ImageIcon(imgURL);
		} else {
			System.err.println("Couldn't find icon: " + path);
			return null;
		}
	}

	public static Icon getIcon(Class<?> c, String key) {
		Class<?> x=I18N.class;
		String path="/icons/"+key.toLowerCase()+".png";
		if (c==null) {
			x = IconUtil.class;
			path="/icons/unknown.png";
		}
		ImageIcon icon = createImageIcon(path);
		if (icon==null) {
			System.err.println("/icon "+path+" not found");
			icon = createImageIcon("/icons/unknown.png");
		}
		return (icon);
	}

	public static Icon getIcon(String path) {
		return(getIcon(I18N.class,path));
	}
	
	public static Icon getIcon(Class<?> c, String key, Dimension dim) {
		Class<?> x=I18N.class;
		if (c==null) {
			x = IconUtil.class;
		}
		java.net.URL url = x.getResource("/icons/"+key.toLowerCase()+".png");
		ImageIcon icon = new ImageIcon(url);
		if (dim!=null) {
			return resizeIcon(icon,dim);
		}
		return(icon);
	}
	
	public static ImageIcon resizeIcon(ImageIcon icon, Dimension size) {
		ImageIcon rs = icon;
		if ((icon.getIconHeight() != size.height) || (icon.getIconWidth() != size.width)) {
			int iw = icon.getIconHeight();
			int ih = icon.getIconWidth();
			int ph = size.height;
			int pw = size.width;
			double scale;
			if (2.0 * pw / iw < 2.0 * ph / ih) {
				scale = 1.0 * pw / iw;
			} else {
				scale = 1.0 * ph / ih;
			}
			int scaledw = (int) (iw * scale);
			int scaledh = (int) (ih * scale);
			Image imageicon = icon.getImage().getScaledInstance(scaledw, scaledh, Image.SCALE_DEFAULT);
			rs = new ImageIcon(imageicon);
		}
		return (rs);
	}

	public static ImageIcon getImageIcon(String resourceKey) {
		java.net.URL imgURL = I18NDlg.class.getResource(resourceKey + ".png");
		return(new ImageIcon(imgURL));
	}

}
